1 REMark ---------- DEMON -----------
2 :
3 REMark Cellular Automata Simulation
4 :
5 REMark By Alan Pemberton, May 1990
6 :
7 REMark Based on an article in
8 :
9 REMark Scientific American, Aug '89
10 CLS
11 WINDOW 512,256,0,0
13 INK 0: PAPER 7: OVER 0: CSIZE 2,1
15 PRINT " DEMON "
30 PRINT" Cellular Automata Simulation"
50 PRINT" By Alan Pemberton, May 1990"
70 PRINT" Based on an article in"
90 PRINT "Scientific American, Aug '89"
95 PRINT "please be patient!"
97 PAUSE 200
100 init
110 set_up_conds
120 display
130 turns=1
140 :
150 REPeat loop
160  AT#0,2,10:PRINT#0,"Generation : ";turns:turns=turns+1
170  calculate
180  display
190  IF CODE(INKEY$(#0))=27:STOP
200 END REPeat loop
210 :
220 DEFine PROCedure init
230  pop_addr=RESPR(3500):temp_addr=pop_addr+1700
240  MODE 8
250  OPEN#3,scr:WINDOW#3,512,256,0,0:PAPER#3,0:CLS#3:WINDOW#3,400,200,40,20
260  RANDOMISE
270 END DEFine init
280 :
290 DEFine PROCedure set_up_conds
295  a=9+9*256+9*256*256+9*256*256*256
300  FOR r=0 TO 1700 STEP 4:POKE_L r+pop_addr,a
310  FOR r=41 TO 1640
320   POKE pop_addr+r,RND(0 TO 7)
330  END FOR r
340  FOR r=0 TO 1700 STEP 4:POKE_L temp_addr+r,PEEK_L(pop_addr+r)
350 END DEFine set_up_conds
360 :
370 DEFine PROCedure calculate
380  LOCal p,q,r
390  FOR r=41 TO 1640
400   p=PEEK(pop_addr+r):q=(p+1)*(p<7)
410   IF PEEK(pop_addr+r-40)=q OR PEEK(pop_addr+r+40)=q OR PEEK(pop_addr+r-1)=q OR PEEK(pop_addr+r+1)=q THEN POKE temp_addr+r,q
420  END FOR r
430  FOR r=0 TO 1700 STEP 4:POKE_L pop_addr+r,PEEK_L(temp_addr+r)
440 END DEFine calculate
450 :
460 DEFine PROCedure display
470  LOCal countx,county,r
480  countx=0:county=0
490  FOR r=41 TO 1640
500   BLOCK#3,10,5,countx,county,PEEK(pop_addr+r)
510   countx=countx+10
520   IF countx=400:countx=0:county=county+5
530  END FOR r
540 END DEFine display
